(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["reduxReducerAsync"] = factory();
	else
		root["reduxReducerAsync"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.finalActionType = finalActionType;
exports.actionTypes = actionTypes;
exports.default = createReducer;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultKeys = {
  loading: 'loading',
  success: 'data',
  error: 'error'
};

function makeDefaultHandlers(keys) {
  return {
    loading: function loading(state) {
      var _extends2;

      return _extends({}, state, (_extends2 = {}, _defineProperty(_extends2, keys.loading, true), _defineProperty(_extends2, keys.error, null), _extends2));
    },
    success: function success(state, action) {
      var _extends3;

      return _extends({}, state, (_extends3 = {}, _defineProperty(_extends3, keys.loading, false), _defineProperty(_extends3, keys.error, null), _defineProperty(_extends3, keys.success, action.payload), _extends3));
    },
    error: function error(state, action) {
      var _extends4;

      return _extends({}, state, (_extends4 = {}, _defineProperty(_extends4, keys.loading, false), _defineProperty(_extends4, keys.error, action.payload), _extends4));
    }
  };
}

function finalActionType(type) {
  return {
    loading: type + '_PENDING',
    success: type,
    error: type
  };
}

function actionTypes(type, loading, success, error) {
  /* eslint-disable no-unneeded-ternary */
  loading = loading == null ? '_PENDING' : loading ? loading : '';
  success = success == null ? '_FULFILLED' : success ? success : '';
  error = error == null ? '_REJECTED' : error ? error : '';
  /* eslint-enable no-unneeded-ternary */
  return {
    loading: '' + type + loading,
    success: '' + type + success,
    error: '' + type + error
  };
}

function createReducer(types, handlers) {
  var initialState = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var safeHandlers = handlers || {};
  var usedTypes = typeof types === 'string' ? actionTypes(types) : _extends({}, types);

  var keys = {};

  keys.loading = typeof safeHandlers.loading === 'string' ? safeHandlers.loading : defaultKeys.loading;
  keys.success = typeof safeHandlers.success === 'string' ? safeHandlers.success : defaultKeys.success;
  keys.error = typeof safeHandlers.error === 'string' ? safeHandlers.error : defaultKeys.error;

  var usedHandlers = _extends({}, safeHandlers);

  var defaultHandlers = makeDefaultHandlers(keys);

  usedHandlers.loading = typeof usedHandlers.loading === 'function' ? usedHandlers.loading : defaultHandlers.loading;
  usedHandlers.success = typeof usedHandlers.success === 'function' ? usedHandlers.success : defaultHandlers.success;
  usedHandlers.error = typeof usedHandlers.error === 'function' ? usedHandlers.error : defaultHandlers.error;

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    switch (action.type) {
      case '' + usedTypes.loading:
        return usedHandlers.loading(state, action);
      case '' + usedTypes.success:
      case '' + usedTypes.error:
        if (action.error) {
          return usedHandlers.error(state, usedHandlers.transformError ? _extends({}, action, {
            payload: usedHandlers.transformError(action.payload)
          }) : action);
        }
        return usedHandlers.success(state, usedHandlers.transform ? _extends({}, action, {
          payload: usedHandlers.transform(action.payload)
        }) : action);
      default:
        return state;
    }
  };
}

/***/ })
/******/ ]);
});